#!/bin/bash

#Usage: 
#echo /what/to/do.sh | getshares.sh
#The script will generate menus that'll call itself as
#echo /what/to/do.sh | getshares.sh machine
#echo /what/to/do.sh | getshares.sh machine share
#echo /what/to/do.sh | getshares.sh machine share "/path"
#echo /what/to/do.sh | getshares.sh machine share "/path/file.avi"
#etc while the user browses through the shares.

MACHINES_FILE=bakken

#Watchdog thingy. Starts a background process which'll wait 8 seconds and the
#kill the script.

scriptPid=$$
{
	sleep 8
	echo "Time-out!"
	kill $scriptPid
	exit 0
} </dev/null &>/dev/null &

#Save pid of the wathdog so we can kill it if it's not necessary anymore
watchdogPid=$!

#Read what we need to invoke any files found with.
read todo

if [ -z "$1" ]; then
	#No args: make a menu with the available machines.
	echo "Samba: Bakken"
	cat $MACHINES_FILE | while read a; do
		echo "$a#|echo \"$todo\" | $0 $a"
	done
else
	if [ -z "$2" ]; then
		#1 arg given: the machine. Use smbclient to fetch any shares the machine has 
		#to offer.
		echo "Shares op $1"
		smbclient -L //$1 -g -U malt -N | grep 'Disk' | grep -v '\$|' | cut -d '|' -f 2 | while read shareName; do
			echo "$shareName#|echo \"$todo\" | $0 $1 $shareName /"
		done
	else 
		#2 or more args given: a machine, a share and a directory.
		#Use smbclient to get a list of that directory.
		#Echo current pwd as the menus header.
		echo $3
		if [ "`basename $0`" = "getsharesplusdir.sh" ]; then
			echo "- All in this dir -#$todo \"smb://$1/$2$3/\""
		fi

		smbclient //$1/$2 -g malt -N -D "$3" -c "ls" 2>/dev/null | egrep -v -e '^ *\.' | egrep '^  ' | head -n 350 | while read a; do
			#This can take a while and we have a connection anyways. Kill the watchdog.
			kill -TERM $watchdogPid 2>/dev/null
			#The internal loop is gonna spit out menulines, but prefixes the ones
			#that are for a directory with A and the ones for a dir with B. That way,
			#when we sort and then cut away the A/B, we end up with the directories first.

			#Cut the dir/filename
			entryName="`echo \"$a\" | sed -r -e 's/^ *//' -e 's/([^ ])   .*$/\1/'`"
			if echo "$a" | grep '  D' > /dev/null; then
				#Filename
				echo "A$entryName#|echo \"$todo\" | $0 $1 $2 \"$3$entryName/\""
			else
				#Directory name
				echo "B$entryName#$todo \"smb://$1/$2$3$entryName\""
			fi
		done | sort | cut -b 2-
	fi
fi

#Hack to make sure the waiting indicator doesn't show up all the time...
echo

#Kill watchdog, it has done its work.
kill -TERM $watchdogPid
