#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "history.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

historyHandle historyLoad(char *file) {
	int no;
	historyHandle ret=historyCreate();
	int fd=open(file, O_RDONLY);
	if (fd<0) return ret;
	historyEntryStruct *s;
	s=malloc(sizeof(historyEntryStruct));
	no=0;
	while(read(fd, s, sizeof(historyEntryStruct))==sizeof(historyEntryStruct)) {
		ret->entries[no]=s;
		no++;
		s=malloc(sizeof(historyEntryStruct));
	}
	free(s);
	ret->len=no;
	return ret;
}

void historyWrite(historyHandle handle, char *file) {
	int n;
	int fd=open(file, O_WRONLY|O_CREAT|O_TRUNC, 0644);
	if (fd<0) return;
	for (n=0; n<handle->len; n++) {
		write(fd, handle->entries[n], sizeof(historyEntryStruct));
	}
	close(fd);
}

historyHandle historyCreate(){
	historyHandle ret;
	ret=malloc(sizeof(historyStruct));
	ret->len=0;
	return ret;
}

void historyPush(historyHandle handle, char *command, int hasArg, char *arg, int choice) {
	historyEntryStruct *s=malloc(sizeof(historyEntryStruct));
	strcpy(s->command, command);
	if (hasArg) {
		strcpy(s->arg, arg);
		s->hasArg=1;
	} else {
		s->hasArg=0;
	}
	s->choice=choice;
	handle->entries[handle->len]=s;
	handle->len++;
}

void historyPop(historyHandle handle, char *command, int *hasArg, char *arg, int *choice) {
	handle->len--;
	historyEntryStruct *s=handle->entries[handle->len];
	strcpy(command, s->command);
	if (s->hasArg) strcpy(arg, s->arg);
	*hasArg=s->hasArg;
	*choice=s->choice;
	if (handle->len==0) {
		handle->len=1;
	} else {
		free(s);
	}
}

int historyLen(historyHandle h) {
	return h->len;
}

void historyFree(historyHandle h) {
	//ToDo, but atm unnecesary: the history only gets free()ed on exit.
}
